using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

public partial class UserControl_PatientMgr : System.Web.UI.UserControl
{
        
    protected void Page_Load(object sender, EventArgs e)
    {
        
            
                    
            txtDOB.Enabled = false;
            txtRegDate.Enabled = false;
            if (!this.IsPostBack)
            {
                FillPatientInfo();
                ddlType.Items.Add("In Patient");
                ddlType.Items.Add("Out Patient");
            }     
        
    }
    
    private void FillPatientInfo()
    {
        ddlPatient.Items.Clear();
       
        string selectSQL = "SELECT FirstName, LastName, PatientID FROM Patient";
                
        SqlConnection con = new SqlConnection(
            "Data Source=TH01;Initial Catalog=PatientInformationDB;Integrated Security=True");
        SqlCommand cmd = new SqlCommand(selectSQL, con);
        SqlDataReader reader;
        
        try
        {
            con.Open();
            reader = cmd.ExecuteReader();
            
            while (reader.Read())
            {
                ListItem newItem = new ListItem();
                newItem.Text = reader["FirstName"] + ", " + reader["LastName"];
                newItem.Value = reader["PatientID"].ToString();
                ddlPatient.Items.Add(newItem);
            }
            reader.Close();
        }
        catch (Exception err)
        {
            lblResults.Text = "Error reading list of names. ";
            lblResults.Text += err.Message;
        }
        finally
        {
            con.Close();
        }
    }
    protected void ddlPatient_SelectedIndexChanged(object sender, EventArgs e)
    {
        string selectSQL;
        selectSQL = "SELECT * FROM Patient ";
        selectSQL += "WHERE PatientID ='" + ddlPatient.SelectedItem.Value + "'";
        SqlConnection con = new SqlConnection(
            "Data Source=TH01;Initial Catalog=PatientInformationDB;Integrated Security=True");
        SqlCommand cmd = new SqlCommand(selectSQL, con);
        SqlDataReader reader;

        
        try
        {
            con.Open();
            reader = cmd.ExecuteReader();
            reader.Read();

            // Fill the controls.
            txtFName.Text = reader["FirstName"].ToString();
            txtLName.Text = reader["LastName"].ToString();
            txtDOB.Text = reader["DateOfBirth"].ToString();
            txtAddress.Text = reader["Address"].ToString();
            txtTown.Text = reader["Town"].ToString();
            txtPCode.Text = reader["PostCode"].ToString();
            txtPhone.Text = reader["Phone"].ToString();
            txtRegDate.Text = reader["RegistrationDate"].ToString();
            txtNextOfKin.Text = reader["NextOfKin"].ToString();
            
            reader.Close();
            lblResults.Text = "";
        }
        catch (Exception err)
        {
            lblResults.Text = "Error getting author. ";
            lblResults.Text += err.Message;
        }
        finally
        {
            con.Close();
        }

    }

    protected void btnUpdate_Click(object sender, EventArgs e)
    {
        string updateSQL;
        updateSQL = "UPDATE Patient SET ";
        updateSQL += "FirstName =@FirstName, LastName=@LastName, DateOfBirth=@DateOfBirth, ";
        updateSQL += "Address=@Address, Town=@Town, PostCode=@PostCode, Phone=@Phone, ";
        updateSQL += "RegistrationDate=@RegistrationDate, NextOfKin=@NextOfKin, PatientType=@PatientType ";
        updateSQL += "WHERE PatientID=@PatientID";

        SqlConnection con = new SqlConnection(
            "Data Source=TH01;Initial Catalog=PatientInformationDB;Integrated Security=True");
        SqlCommand cmd = new SqlCommand(updateSQL, con);

        // Add the parameters.
        cmd.Parameters.AddWithValue("@FirstName", txtFName.Text);
        cmd.Parameters.AddWithValue("@LastName", txtLName.Text);
        cmd.Parameters.AddWithValue("@DateOfBirth", txtDOB.Text);
        cmd.Parameters.AddWithValue("@Address", txtAddress.Text);
        cmd.Parameters.AddWithValue("@Town", txtTown.Text);
        cmd.Parameters.AddWithValue("@PostCode", txtPCode.Text);
        cmd.Parameters.AddWithValue("@Phone", txtPhone.Text);
        cmd.Parameters.AddWithValue("@RegistrationDate", txtRegDate.Text);
        cmd.Parameters.AddWithValue("@NextOfKin", txtNextOfKin.Text);
        cmd.Parameters.AddWithValue("@PatientType", ddlType.SelectedItem.Text);
        cmd.Parameters.AddWithValue("@PatientID", ddlPatient.SelectedItem.Value);

        // Try to open database and execute the update.
        try
        {
            con.Open();
            int updated = cmd.ExecuteNonQuery();
            lblResults.Text = updated.ToString() + " records updated.";
        }
        catch (Exception err)
        {
            lblResults.Text = "Error updating Patient. ";
            lblResults.Text += err.Message;
        }
        finally
        {
            con.Close();
        }

    }
}
